#import "AppController.h"

@implementation AppController

- (void) awakeFromNib
{
	[showMe setEnabled: NO];
	
	myLocation = [[CLLocationManager alloc] init];
	[myLocation setDelegate: self];
	[myLocation startUpdatingLocation];
}

- (void) dealloc 
{
	[myLocation release];
	[super dealloc];
}

- (IBAction) showLocation: (id) sender
{
	NSString* mapString = [NSString stringWithFormat:@"http://maps.google.com/?q=%2.8f,%2.8f&z=13", myCoordinates.latitude, myCoordinates.longitude];
	[[NSWorkspace sharedWorkspace] openURL: [NSURL URLWithString: mapString]];
}

#pragma mark CLLocationManagerDelegate methods

- (void) locationManager: (CLLocationManager*) manager
     didUpdateToLocation: (CLLocation*) newLocation
						fromLocation: (CLLocation*) oldLocation
{
	myCoordinates = [newLocation coordinate];
	[myLatitude setStringValue: [NSString stringWithFormat: @"%2.6f", myCoordinates.latitude]];
	[myLongitude setStringValue: [NSString stringWithFormat: @"%2.6f", myCoordinates.longitude]]; 
	[showMe setEnabled: YES];
}

- (void) locationManager: (CLLocationManager*) manager
				didFailWithError: (NSError*) error
{
	NSAlert *theAlert = [NSAlert alertWithError: error]; 
	[theAlert runModal];
}

@end
