#import "PhoneLocationAppDelegate.h"

@implementation PhoneLocationAppDelegate

@synthesize myWindow;

- (void)applicationDidFinishLaunching: (UIApplication*) application 
{	
	// Override point for customization after app launch	
  [myWindow makeKeyAndVisible];
	
	[showMe setEnabled: NO];
	
	myLocation = [[CLLocationManager alloc] init];
	[myLocation setDelegate: self];
	[myLocation startUpdatingLocation];
}

- (void) dealloc 
{
	[myLocation release];
	[myWindow release];
	[super dealloc];
}

- (IBAction) showLocation: (id) sender
{
	NSString* mapString = [NSString stringWithFormat:@"http://maps.google.com/?q=%2.8f,%2.8f&z=13", myCoordinates.latitude, myCoordinates.longitude];
	[[UIApplication sharedApplication] openURL: [NSURL URLWithString: mapString]];
}

#pragma mark CLLocationManagerDelegate methods

- (void) locationManager: (CLLocationManager*) manager
     didUpdateToLocation: (CLLocation*) newLocation
						fromLocation: (CLLocation*) oldLocation
{
	myCoordinates = [newLocation coordinate];
	[myLatitude setText: [NSString stringWithFormat: @"%2.6f", myCoordinates.latitude]];
	[myLongitude setText: [NSString stringWithFormat: @"%2.6f", myCoordinates.longitude]]; 
	[showMe setEnabled: YES];
}

- (void) locationManager: (CLLocationManager*) manager
				didFailWithError: (NSError*) error
{
	UIAlertView* theAlert = [[UIAlertView alloc] initWithTitle: [error localizedDescription] message: [error localizedFailureReason] delegate: nil cancelButtonTitle: nil otherButtonTitles: nil]; 
	[theAlert show];
}

@end
